// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.
// GLOBAL VARIABLES
var password;
var currentTab;
var ready;
var passwordEntered;
//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
	changeTabScripts();
	hiddenFilesAreShowing=false;
	if (widget.preferenceForKey("userpass")==undefined)
	{
	needPassword();
	showBack();
	}
	else
	{
	password=widget.preferenceForKey("userpass");
	validatePassword();
	}
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}
// Begin MaintenanceWidget specific code...

//sets the status to ready
function setStatusToReady()
{
	ready=true;
	document.getElementById("statustext").innerText="READY";
	if(currentTab=="scriptimg")
		changeTabScripts();
	else if(currentTab=="trashimg")
		changeTabTrash();
	else if(currentTab=="diskimg")
		changeTabDisk();
	else if(currentTab=="finderimg")
		changeTabFinder();
	else
		alert('TAB STATUS ERROR');
		
	//enableAllButtons();
	
}
//sets the statut to busy
function setStatusToBusy()
{
	ready=false;
	document.getElementById("statustext").innerText="WORKING";
	disableAllButtons();
}
//warns the user of an incorrect password
function incorrectPassword()
{
	ready=false;
	document.getElementById("statustext").innerText="WRONG PASSWORD";
	disableAllButtons();
}
//warns the user if a password has not been entered
function needPassword()
{
	ready=false;
	document.getElementById("statustext").innerText="PASSWORD NEEDED";
	disableAllButtons();	
}
//goes to the homepage
function goHome(event)
{
    widget.openURL('http://www.bradflaugher.com');
}
//plays the animation for changing tabs.
function changeTabScripts(event)
{
	currentTab="scriptimg";
	//disable stuff on other tabs
	disableButton("trashbutton");
	disableButton("diskbutton");
	disableButton("finderbutton");
	disableButton("hiddenfilesbutton");
	//hide stuff on other tabs
	fadeOutObject("trashtab");
	fadeOutObject("disktab");
	fadeOutObject("findertab");
	fadeOutObject("trashbutton");
	fadeOutObject("diskbutton");
	fadeOutObject("finderbutton");
	fadeOutObject("hiddenfilesbutton");
	fadeOutObject("description");
	partialFadeOutObject("trashimg");
	partialFadeOutObject("diskimg");
	partialFadeOutObject("finderimg");
	document.getElementById("description").innerText="Use these periodic UNIX maintenance scripts to help improve performance.";
	//enable stuff on this tab
	enableButton("dailybutton");
	enableButton("weeklybutton");
	enableButton("monthlybutton");
	//show the stuff on this tab
	fadeInObject("scriptimg");
	fadeInObject("dailybutton");
	fadeInObject("weeklybutton");
	fadeInObject("monthlybutton");
	fadeInObject("description");
	fadeInObject("scripttab");	
}
//plays the animation for changing tabs
function changeTabTrash(event)
{
	currentTab="trashimg";
	//disable stuff on other tabs
	disableButton("dailybutton");
	disableButton("weeklybutton");
	disableButton("monthlybutton");
	disableButton("diskbutton");
	disableButton("finderbutton");
	disableButton("hiddenfilesbutton");
	//hide stuff on other tabs
	fadeOutObject("hiddenfilesbutton");
	fadeOutObject("scripttab");
	fadeOutObject("disktab");
	fadeOutObject("findertab");
	fadeOutObject("diskbutton");
	fadeOutObject("description");
	fadeOutObject("dailybutton");
	fadeOutObject("weeklybutton");
	fadeOutObject("monthlybutton");
	fadeOutObject("finderbutton");
	partialFadeOutObject("scriptimg");
	partialFadeOutObject("diskimg");
	partialFadeOutObject("finderimg");
	document.getElementById("description").innerText="This forces the trash to empty, which is handy if you keep getting errors.";
	//enable stuff on this tab
	enableButton("trashbutton");
	//show the stuff on this tab
	fadeInObject("trashimg");
	fadeInObject("trashbutton");
	fadeInObject("description");
	fadeInObject("trashtab");	
}
//plays the animation for changing tabs 
function changeTabDisk(event)
{
	currentTab="diskimg";
	//disable stuff on other tabs
	disableButton("dailybutton");
	disableButton("weeklybutton");
	disableButton("monthlybutton");
	disableButton("trashbutton");
	disableButton("finderbutton");
	disableButton("hiddenfilesbutton");
	//hide stuff on other tabs
	fadeOutObject("scripttab");
	fadeOutObject("trashtab");
	fadeOutObject("findertab");
	fadeOutObject("trashbutton");
	fadeOutObject("description");
	fadeOutObject("dailybutton");
	fadeOutObject("weeklybutton");
	fadeOutObject("monthlybutton");
	fadeOutObject("finderbutton");
	fadeOutObject("hiddenfilesbutton");
	partialFadeOutObject("scriptimg");
	partialFadeOutObject("trashimg");
	partialFadeOutObject("finderimg");
	document.getElementById("description").innerText="This repairs the disk permissions on the startup disk, just like disk utility!";
	//enable stuff on this tab
	enableButton("diskbutton");
	//show the stuff on this tab
	fadeInObject("diskimg");
	fadeInObject("diskbutton");
	fadeInObject("description");
	fadeInObject("disktab");
}
//plays the animation for changing tabs 
function changeTabFinder(event)
{
	currentTab="finderimg";
	//disable stuff on other tabs
	disableButton("dailybutton");
	disableButton("weeklybutton");
	disableButton("monthlybutton");
	disableButton("trashbutton");
	disableButton("diskbutton");
	//hide stuff on other tabs
	fadeOutObject("scripttab");
	fadeOutObject("trashtab");
	fadeOutObject("disktab");
	fadeOutObject("trashbutton");
	fadeOutObject("description");
	fadeOutObject("dailybutton");
	fadeOutObject("weeklybutton");
	fadeOutObject("monthlybutton");
	fadeOutObject("diskbutton");
	partialFadeOutObject("scriptimg");
	partialFadeOutObject("trashimg");
	partialFadeOutObject("diskimg");
	document.getElementById("description").innerText="Some handy finder tools.";
	//enable stuff on this tab
	enableButton("finderbutton");
	enableButton("hiddenfilesbutton");
	//show the stuff on this tab
	fadeInObject("finderimg");
	fadeInObject("finderbutton");
	fadeInObject("hiddenfilesbutton");
	fadeInObject("description");
	fadeInObject("findertab");
}

//fades out the tab icons to 50% opacity
function partialFadeOutObject(ID)
{
	var itemToFadeOut = document.getElementById(ID);
	// Fading code
	var fadeHandler = function(a, c, s, f){ itemToFadeOut.style.opacity = c; };
	var currentOpacity = itemToFadeOut.style.opacity;
	new AppleAnimator(1, 13, currentOpacity, .5, fadeHandler).start();
}
//completeley fades out an object
function fadeOutObject(ID)
{
	var itemToFadeOut = document.getElementById(ID);
	// Fading code
	var fadeHandler = function(a, c, s, f){ itemToFadeOut.style.opacity = c; };
	var currentOpacity = itemToFadeOut.style.opacity;
	new AppleAnimator(1, 13, currentOpacity, 0.0, fadeHandler).start();
}
//fades in an object
function fadeInObject(ID)
{
	var itemToFadeIn = document.getElementById(ID);
	// Fading code
	var fadeHandler = function(a, c, s, f){ itemToFadeIn.style.opacity = c; };
	var currentOpacity = itemToFadeIn.style.opacity;
	new AppleAnimator(100, 13, currentOpacity, 1.0, fadeHandler).start();

}
//disables buttons
function disableButton(ID)
{
	document.getElementById(ID).object.setEnabled(false);
	
	if(ID != "hiddenfilesbutton")
		moveButtonAway(ID);
}
//enables buttons
function enableButton(ID)
{
	if (ready==true)
		document.getElementById(ID).object.setEnabled(true);
	
	if(ID != "hiddenfilesbutton")
		moveButtonReady(ID);
}
//disables all buttons
function disableAllButtons()
{
	document.getElementById("dailybutton").object.setEnabled(false);
	document.getElementById("weeklybutton").object.setEnabled(false);
	document.getElementById("monthlybutton").object.setEnabled(false);
	document.getElementById("diskbutton").object.setEnabled(false);
	document.getElementById("trashbutton").object.setEnabled(false);
	document.getElementById("finderbutton").object.setEnabled(false);
}

function enableAllButtons()
{
	document.getElementById("dailybutton").object.setEnabled(true);
	document.getElementById("weeklybutton").object.setEnabled(true);
	document.getElementById("monthlybutton").object.setEnabled(true);
	document.getElementById("diskbutton").object.setEnabled(true);
	document.getElementById("trashbutton").object.setEnabled(true);
	document.getElementById("finderbutton").object.setEnabled(true);
}
function enterPassword(event)
{
	password=document.getElementById("password").value;
	document.getElementById("password").value="";
	validatePassword();
	showFront();
}
function validatePassword()
{
	widget.system("echo " + password + " | sudo -S ls", finishValidate);
}
// this is the handler that actually validates the password
function finishValidate(outputObject)
{
	if(outputObject.outputString==undefined)
	{
		widget.setPreferenceForKey(null,"userpass");
		alert('wrong password');
		incorrectPassword();
	}
	else
	{
		widget.setPreferenceForKey(password,"userpass");
		alert('password is correct');
		passwordEntered=true;
		setStatusToReady();
	}
	var command = "/usr/bin/sudo -k";
	var handler = function(){ };
	widget.system(command, handler);
}

function finishCommand()
{
	var command = "/usr/bin/sudo -k";
	var handler = function(){ setStatusToReady(); };
	widget.system(command, handler);
}

function runDailyScripts(event)
{
	setStatusToBusy();
	var command = "echo " + password + " | sudo -S periodic daily";
	var handler = function(){finishCommand();};
	widget.system(command, handler);
}

function runWeeklyScripts(event)
{
	setStatusToBusy();
	var command = "echo " + password + " | sudo -S periodic daily weekly";
	var handler = function(){finishCommand();};
	widget.system(command, handler);
}

function runMonthlyScripts(event)
{
	setStatusToBusy();
	var command = "echo " + password + " | sudo -S periodic daily weekly monthly";
	var handler = function(){finishCommand();};
	widget.system(command, handler);
}

function emptyTrash(event)
{
	setStatusToBusy();
	var command = "echo " + password + " | sudo -S rm -rf ~/.Trash/*";
	var handler = function(){finishCommand();};
	widget.system(command, handler);
}

function repairPermissions(event)
{
	setStatusToBusy();
	var command = "echo " + password + " | sudo -S diskutil repairPermissions /";
	var handler = function(){finishCommand();};
	widget.system(command, handler);
}


function resetFinder()
{
	var command = "echo " + password + " | sudo -S killall Finder";
	var handler = function(){finishCommand();};
	widget.system(command, handler);
}

function readDefaultFileValue() 
{
return widget.system('sh -c "defaults read com.apple.Finder AppleShowAllFiles"', null).outputString;
}

function toggleHiddenFiles()
{
	var areFilesShowing=readDefaultFileValue();
	areFilesShowing=areFilesShowing.substring(0,1);
	//alert(areFilesShowing);
	
	if(areFilesShowing=="Y")
	{
	var command = 'sh -c "defaults write com.apple.Finder AppleShowAllFiles NO"';
	var handler = function(){finishCommand();};
	widget.system(command, handler);
	resetFinder();
	}
	else
	{
	var command = 'sh -c "defaults write com.apple.Finder AppleShowAllFiles YES"';
	var handler = function(){finishCommand();};
	widget.system(command, handler).errorString;
	resetFinder();
	}
}


function moveButtonReady(ID)
{
// Values you provide
var itemToMove = document.getElementById(ID);	// replace with ID of element to move
var moveToTopPosition = 117;							// new top CSS value

// Moving code
var originalTop = parseInt(document.defaultView.getComputedStyle(itemToMove, null).getPropertyValue("top"));
var moveHandler = function(a, c, s, f){ itemToMove.style.top = c + "px"; };
new AppleAnimator(200, 13, originalTop, moveToTopPosition, moveHandler).start();
}

function moveButtonAway(ID)
{
// Values you provide
var itemToMove = document.getElementById(ID);
var moveToTopPosition = 91;							// new top CSS value

// Moving code
var originalTop = parseInt(document.defaultView.getComputedStyle(itemToMove, null).getPropertyValue("top"));
var moveHandler = function(a, c, s, f){ itemToMove.style.top = c + "px"; };
new AppleAnimator(100, 13, originalTop, moveToTopPosition, moveHandler).start();
}



function highlightTrashTab(event)
{
	fadeInObject("trashimg");
	
	if (currentTab!="finderimg")
		partialFadeOutObject("finderimg");
    if (currentTab!="diskimg")
		partialFadeOutObject("diskimg");
	if (currentTab!="scriptimg")
		partialFadeOutObject("scriptimg");	
}


function highlightScriptsTab(event)
{
    fadeInObject("scriptimg");
	
	if (currentTab!="finderimg")
		partialFadeOutObject("finderimg");
    if (currentTab!="diskimg")
		partialFadeOutObject("diskimg");
    if (currentTab!="trashimg")
		partialFadeOutObject("trashimg");
}


function highlightDiskTab(event)
{
    fadeInObject("diskimg");
	
	if (currentTab!="finderimg")
		partialFadeOutObject("finderimg");
	if (currentTab!="trashimg")
		partialFadeOutObject("trashimg");
	if (currentTab!="scriptimg")
		partialFadeOutObject("scriptimg");
}


function highlightFinderTab(event)
{
    fadeInObject("finderimg");
	
	if (currentTab!="diskimg")
		partialFadeOutObject("diskimg");
    if (currentTab!="trashimg")
		partialFadeOutObject("trashimg");
	if (currentTab!="scriptimg")
		partialFadeOutObject("scriptimg");
}


function delightFinderTab(event)
{
    if (currentTab!="finderimg")
		partialFadeOutObject("finderimg");
}


function delightDiskTab(event)
{
    if (currentTab!="diskimg")
		partialFadeOutObject("diskimg");
}


function delightTrashTab(event)
{
    if (currentTab!="trashimg")
		partialFadeOutObject("trashimg");
}


function delightScriptsTab(event)
{
    if (currentTab!="scriptimg")
		partialFadeOutObject("scriptimg");
}


function goLouie(event)
{
    widget.openURL('http://louiemantia.com/');
}
